
/*
 *  chdir.c
 */

#include <exec/types.h>
#include <libraries/dos.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct FileInfoBlock FIB;

int
chdir(path)
const char *path;
{
    int r = -1;
    BPTR lock;

    if (lock = Lock(path, SHARED_LOCK)) {
	FIB *fib = malloc(sizeof(FIB));
	if (fib) {
	    if (Examine(lock, fib) && fib->fib_DirEntryType > 0) {
		r = 0;
		lock = CurrentDir(lock);
	    }
	    free(fib);
	}
	UnLock(lock);
    }
    return(r);
}


